<script lang="ts">
  import { questions, answers, ended } from "../store";

  let questionId = 0;
  let questionCount = $questions.length;

  let shuffle = false;

  function mark(answer: "correct" | "incorrect") {
    if (questionId >= questionCount) {
      throw "haha excuse me what the fuck";
    }

    answers.update((a) => {
      const newAnswers = a.slice();
      newAnswers[questionId] = {
        answered: true,
        answer: answer,
      };

      return newAnswers;
    });
  }

  function next() {
    if (questionId == questionCount - 1) {
      throw "haha excuse me what the fuck";
    }
    shuffle = Math.random() < 0.5;
    questionId++;
  }

  function end() {
    fetch("https://api.jsonbin.io/v3/b", {
      method: "POST", // *GET, POST, PUT, DELETE, etc.
      headers: {
        "Security-Comment":
          "We know this is a security risk. But the service is free and simple to set up (altho you can't create update-only key). Only thing you can do with the master key is to destroy our collection answers. So please don't.",
        "Content-Type": "application/json",
        "X-Master-Key":
          "$2b$10$805/JQOuky/OXY4kybXYlujQqZT7LjmndEOVe7n2ZyzniZN/pWs3G",
        // 'Content-Type': 'application/x-www-form-urlencoded',
      },
      body: JSON.stringify($answers.map((a) => a.answer)), // body data type must match "Content-Type" header
    });

    ended.update((e) => true);
  }
</script>

<div>
  {#if $answers[questionId].answered}
    <div class="answer {$answers[questionId].answer}">
      You are {$answers[questionId].answer}!
    </div>

    <div>
      <span class="paper-name">{$questions[questionId].fake}</span> was generated
      using our generator.
    </div>
    <div>
      <span class="paper-name">{$questions[questionId].real}</span> is a real
      paper with DOI
      <a href="https://doi.org/{$questions[questionId].realDoi}" target="_blank"
        >{$questions[questionId].realDoi}</a
      >
    </div>

    {#if $answers.every((a) => a.answered)}
      <button on:click={end}>End!</button>
    {:else}
      <button on:click={next}>Next!</button>
    {/if}
  {:else}
    <div class="answer">Which one is the published paper?</div>
    {#if shuffle}
      <button on:click={() => mark("correct")}
        >{$questions[questionId].real}</button
      >
      <button on:click={() => mark("incorrect")}
        >{$questions[questionId].fake}</button
      >
    {:else}
      <button on:click={() => mark("incorrect")}
        >{$questions[questionId].fake}</button
      >
      <button on:click={() => mark("correct")}
        >{$questions[questionId].real}</button
      >
    {/if}
  {/if}
</div>

<style>
  .answer {
    font-size: x-large;
    margin: 1em;
  }
  .incorrect {
    color: red;
  }
  .correct {
    color: limegreen;
  }
  .paper-name {
    font-style: italic;

    color: darkgray;
  }
</style>
